nix-prefetch-hg: Various bash style improvements, fixes #9511

This commit is contained in:
Benjamin Staffin 2015-08-28 20:28:32 -07:00 committed by Rok Garbas
parent ef4ea6d673
commit fc85f1beed

View file

@ -5,79 +5,79 @@ url=$1
rev=$2 rev=$2
expHash=$3 expHash=$3
hashType=$NIX_HASH_ALGO hashType="${NIX_HASH_ALGO:-sha256}"
if test -z "$hashType"; then hashFormat=${hashFormat:-"--base32"}
hashType=sha256 rev="${rev:-tip}"
fi
if test -z "$hashFormat"; then LOG() {
hashFormat=--base32 echo "$@" >&2
}
die() {
LOG "$@"
exit 1
}
if [[ -z "$url" || "$url" == "--help" ]]; then
die "Usage: nix-prefetch-hg URL [rev [EXPECTED-HASH]]"
fi fi
if test -z "$url"; then if [[ "${fetchSubrepos:-0}" == 1 ]]; then
echo "syntax: nix-prefetch-hg URL [rev [EXPECTED-HASH]]" >&2
exit 1
fi
if test "$fetchSubrepos" == 1; then
subrepoClause=S subrepoClause=S
else else
subrepoClause= subrepoClause=
fi fi
test -n "$rev" || rev="tip"
# If the hash was given, a file with that hash may already be in the # If the hash was given, a file with that hash may already be in the
# store. # store.
if test -n "$expHash"; then if [[ -n "$expHash" ]]; then
finalPath=$(nix-store --print-fixed-path --recursive "$hashType" "$expHash" hg-archive) finalPath=$(nix-store --print-fixed-path --recursive "$hashType" "$expHash" hg-archive)
if ! nix-store --check-validity "$finalPath" 2> /dev/null; then if ! nix-store --check-validity "$finalPath" 2> /dev/null; then
finalPath= finalPath=
fi fi
hash=$expHash hash="$expHash"
fi fi
# If we don't know the hash or a path with that hash doesn't exist, # If we don't know the hash or a path with that hash doesn't exist,
# download the file and add it to the store. # download the file and add it to the store.
if test -z "$finalPath"; then if [[ -z "$finalPath" ]]; then
tmpPath="$(mktemp -d "${TMPDIR:-/tmp}/hg-checkout-tmp-XXXXXXXX")" tmpPath="$(mktemp -d "${TMPDIR:-/tmp}/hg-checkout-tmp-XXXXXXXX")"
trap "rm -rf \"$tmpPath\"" EXIT cleanup() { x=$?; rm -rf "$tmpPath"; exit $x; }; trap cleanup EXIT
tmpArchive="$tmpPath/hg-archive" tmpArchive="$tmpPath/hg-archive"
# Perform the checkout. # Perform the checkout.
if [[ $url != /* ]]; then if [[ "$url" != /* ]]; then
tmpClone=$tmpPath/hg-clone tmpClone="$tmpPath/hg-clone"
hg clone -q -y -U "$url" $tmpClone >&2 hg clone -q -y -U "$url" "$tmpClone" >&2
else else
tmpClone=$url tmpClone=$url
fi fi
hg archive -q$subrepoClause -y -r "$rev" --cwd $tmpClone $tmpArchive hg archive -q$subrepoClause -y -r "$rev" --cwd "$tmpClone" "$tmpArchive"
rm -f $tmpArchive/.hg_archival.txt rm -f "$tmpArchive/.hg_archival.txt"
echo "hg revision is $(cd $tmpClone; hg id -r "$rev" -i)" LOG "hg revision is $(cd "$tmpClone"; hg id -r "$rev" -i)"
# Compute the hash. # Compute the hash.
hash=$(nix-hash --type $hashType $hashFormat $tmpArchive) hash=$(nix-hash --type "$hashType" "$hashFormat" "$tmpArchive")
if ! test -n "$QUIET"; then echo "hash is $hash" >&2; fi if [[ -z "$QUIET" ]]; then LOG "hash is $hash"; fi
# Add the downloaded file to the Nix store. # Add the downloaded file to the Nix store.
finalPath=$(nix-store --add-fixed --recursive "$hashType" $tmpArchive) finalPath=$(nix-store --add-fixed --recursive "$hashType" "$tmpArchive")
if test -n "$expHash" -a "$expHash" != "$hash"; then if [[ -n "$expHash" && "$expHash" != "$hash" ]]; then
echo "hash mismatch for URL \`$url'" die "ERROR: hash mismatch for URL \`$url'"
exit 1
fi fi
fi fi
if ! test -n "$QUIET"; then echo "path is $finalPath" >&2; fi if [[ -z "$QUIET" ]]; then LOG "path is $finalPath"; fi
echo $hash echo "$hash"
if test -n "$PRINT_PATH"; then if [[ -n "$PRINT_PATH" ]]; then
echo $finalPath echo "$finalPath"
fi fi